#include "mad.h"

#include <string.h>
#include <stdlib.h>
#include <ctype.h>
//for isspace

/*
boolean isempty(const char *c){
   if (c == NULL)
      return true;
   
   return (strlen(c) == 0);
   return (c == NULL)
 ? NULL : (strlen(c) == 0);
};

char *strdupn(const char *c){
   if (isempty(c))
      return NULL;

   return strdup(c);

   return (isempty(c))
 ? NULL : strdup(c);
};

int  strcmpn(const char *c1, const char *c2){
   if ((c1 == NULL) ||
       (c2 == NULL))
      return 1;
   return strcmp(c1, c2);

   return (!c1 || !c2) ? 1 : strcmp(c1, c2);
};
*/

char *to_upper(char *c){
   if (isempty(c))
      return NULL;
   for(unsigned int i=0; i<strlen(c); i++)
      c[i]=toupper(c[i]);
   return c;
};

char *to_lower(char *c){
   if (isempty(c))
      return NULL;
   for(unsigned int i=0; i<strlen(c); i++)
      c[i]=tolower(c[i]);
   return c;
};

char *strcut(char *c){
   if (isempty(c))
      return NULL;
      
   int len = strlen(c);

   int i;

   for (i = len - 1; i >= 0; i--)
      if ( isspace(c[i]) )
         c[i] = '\0';
      else
         break;

   int e = 0;

   for (i = 0; i < len; i++)
      if ( isspace(c[i]) )
         e = i + 1;
      else
         break;

   if (e >= len)
      return NULL;

   return &c[e];
};

long int file2char(const char *filename, char *buffer, long int size){
   FILE *f = fopen(filename, "r");

   if (f == NULL){
      buffer[0] = '\0';
      return -1;
   }

   unsigned int act = fread(buffer, 1, size, f);
   buffer[act] = '\0'; //(: may?!?!? :)

   fclose(f);

   return act;
}

char *filegets(char *buffer, int max, FILE *f){
   char *tmp = fgets(buffer, max, f);

   if (tmp == NULL)
      return NULL;

   for (int i = strlen(buffer) - 1; i >= 0; i--)
      if (buffer[i] == '\n'){
         buffer[i] = '\0';
         break;
      }

   return buffer;
};

char *strconcat(const char *x1,
                const char *x2,
                const char *x3,
                const char *x4,
                const char *x5){

   StringBuffer *sb = new StringBuffer();
   sb->add(x1);
   sb->add(x2);
   sb->add(x3);
   sb->add(x4);
   sb->add(x5);

   char *dest = strdupn(sb->get());

   delete(sb);

   return dest;
};

void replacechar(char *buffer, char c1, char c2){
   if (isempty(buffer))
      return;
   for (unsigned int i = 0; i < strlen(buffer); i++)
      if (buffer[i] == c1)
         buffer[i] = c2;
}

char *itoa(int value, char *buff){
   sprintf(buff, "%d", value); //BUG?!?! \0
   
   return buff;
   
   //itoa(value, tmp, 10); //bc - ok; gcc - error ?!?!?
};

char *itoa(int value){
   static char tmp[50];
   return itoa(value, tmp);
};

int setenv(const char *name, const char *value, char *buffer){
   free(buffer);
   buffer = strconcat(name, "=", value);
   int  i = putenv(buffer);
   //free(buffer);
   return i;
};

void StringBuffer::add(const char c){
   char tmp[] = {c, '\0'};
   add(tmp);
};

void StringBuffer::add(const char *c){
   if (isempty(c)) 
      return;

   char *tmp = (char *) malloc(strlen(data) + strlen(c) + 1);
   strcpy(tmp, data);
   strcat(tmp, c);
   free(data);
   data = tmp;
};

const char *StringTokenizer::nextToken(){
   if ((index >= len) ||
       (data == NULL))
      return NULL;

   int index1 = index;

   while ((index < len        ) &&
          (data[index] != delim))
      index++;

   data[index] = '\0';
   index++;

   return &data[index1];
};

const char *StringTokenizer::nextToEnd(){
   if ((index >= len) ||
       (data == NULL))
      return NULL;

   return &data[index];
};
